<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_currency.php                                       ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("static_tables");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_currency.html");

	$t->set_var("admin_currency_href", "admin_currency.php");
	$t->set_var("admin_currencies_href", "admin_currencies.php");
	$t->set_var("admin_lookup_tables_href", "admin_lookup_tables.php");

	$r = new VA_Record($table_prefix . "currencies");
	$r->return_page  = "admin_currencies.php";

	$yes_no = 
		array( 
			array(1, "Yes"), array(0, "No")
		);

	$r->add_where("currency_id", INTEGER);
	$r->add_checkbox("is_default", INTEGER);
	$r->add_checkbox("recalculate_prices", INTEGER);
	$r->change_property("recalculate_prices", USE_IN_SELECT, false);
	$r->change_property("recalculate_prices", USE_IN_INSERT, false);
	$r->change_property("recalculate_prices", USE_IN_UPDATE, false);

	$r->add_textbox("currency_code", TEXT, "Currency Code");
	$r->change_property("currency_code", REQUIRED, true);
	$r->change_property("currency_code", UNIQUE, true);
	$r->change_property("currency_code", MIN_LENGTH, 3);
	$r->change_property("currency_code", MAX_LENGTH, 3);
	$r->add_textbox("currency_value", TEXT);
	$r->add_textbox("currency_title", TEXT, "Currency Title");
	$r->change_property("currency_title", REQUIRED, true);
	$r->add_textbox("currency_image", TEXT, "Currency Image");
	$r->add_textbox("currency_image_active", TEXT, "Currency Image Active");
	$r->add_textbox("exchange_rate", NUMBER, "Exchange Rate");
	$r->change_property("exchange_rate", REQUIRED, true);
	$r->change_property("exchange_rate", DEFAULT_VALUE, 1);
	$r->add_textbox("symbol_left", TEXT);
	$r->add_textbox("symbol_right", TEXT);

	$r->events[BEFORE_INSERT] = "recalculate_rates";
	$r->events[BEFORE_UPDATE] = "recalculate_rates";
	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("date_added_format", join("", $date_edit_format));
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_currencies_href", "admin_currencies.php");
	$t->pparse("main");

	function recalculate_rates()
	{
		global $r, $db, $table_prefix;
		$exchange_rate = $r->get_value("exchange_rate");
		if ($r->get_value("is_default") == 1) {

			if ($exchange_rate != 1) {
				if ($r->get_value("recalculate_prices") == 1) {
					$sql  = " UPDATE " . $table_prefix . "items SET ";
					$sql .= " buying_price=buying_price*" . $db->tosql($exchange_rate, NUMBER) . ", ";
					$sql .= " sales_price=sales_price*" . $db->tosql($exchange_rate, NUMBER) . ", ";
					$sql .= " price=price*" . $db->tosql($exchange_rate, NUMBER) . ", ";
					$sql .= " shipping_cost=shipping_cost*" . $db->tosql($exchange_rate, NUMBER);
					$db->query($sql);
		  
					$sql  = " UPDATE " . $table_prefix . "items_properties_values SET ";
					$sql .= " additional_price=additional_price*" . $db->tosql($exchange_rate, NUMBER);
					$db->query($sql);
				}
		  
				$sql  = " UPDATE " . $table_prefix . "currencies SET exchange_rate=exchange_rate/" . $db->tosql($exchange_rate, NUMBER);
				$db->query($sql);
				$r->set_value("exchange_rate", 1);
			}

			$sql  = " UPDATE " . $table_prefix . "currencies SET is_default=0 ";
			$db->query($sql);
			set_session("session_currency", "");
		}
	}

?>