<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_forum_edit.php                                     ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");

	check_admin_security("forum");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main", "admin_forum_edit.html");

	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_forum_href", "admin_forum.php");
	$t->set_var("admin_forum_edit_href", "admin_forum_edit.php");

	$r = new VA_Record($table_prefix . "forum_list");
	$r->return_page = "admin_forum.php";

	$admins =array();
	$sql = " SELECT admin_id, admin_name FROM " . $table_prefix . "admins ORDER BY admin_id ASC";
	$db->query($sql);
	if ($db->next_record()) {
		$usr = new VA_Record($table_prefix . "admins");
		do {
			$admins[$db->f("admin_id")] = $db->f("admin_name");
			$usr->add_checkbox("admin_" . $db->f("admin_id"), INTEGER);
		}
		while($db->next_record());
	}	

	$r->get_form_values();
	$usr->get_form_values();

	$r->add_where("forum_id", INTEGER);
	$r->add_textbox("forum_order", TEXT, "Forum order");
	$r->change_property("forum_order", REQUIRED, true);
	$r->add_textbox("forum_name", TEXT, "Forum name");
	$r->change_property("forum_name", REQUIRED, true);
	$r->change_property("forum_name", MAX_LENGTH, 255);
	$r->add_textbox("friendly_url", TEXT, "Friendly URL");
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");
	$r->add_textbox("short_description", TEXT);
	$r->add_textbox("full_description", TEXT);

	// forum settings
	$allowed_values = array(array("0", "Nobody"), array("1", "All users"), array("2", "Registered users only"));
	$r->add_radio("allowed_view", INTEGER, $allowed_values, "Allow view forum");
	$r->add_radio("allowed_view_topics", INTEGER, $allowed_values, "Allow view forum topics list");
	$r->add_radio("allowed_view_topic", INTEGER, $allowed_values, "Allow view forum topics details");
	$r->add_radio("allowed_post_topics", INTEGER, $allowed_values, "Allow post new topics");
	$r->add_radio("allowed_post_replies", INTEGER, $allowed_values, "Allow post replies");

	$r->add_textbox("small_image", TEXT);
	$r->add_textbox("large_image", TEXT);

	$sql = "SELECT category_id, category_name FROM " . $table_prefix . "forum_categories";
	$categories = get_db_values($sql, array(array("", "Select Category")));
	if (sizeof($categories) == 1) {
		$categories = array(array("", "Forum categories not available"));
	}
	$r->add_select("category_id", TEXT, $categories, "Category");
	$r->change_property("category_id", REQUIRED, true);

	$r->add_textbox("date_added", DATETIME, "Date Added");
	$r->change_property("date_added", USE_IN_UPDATE, false);
	$r->add_textbox("threads_number", TEXT);
	$r->change_property("threads_number", USE_IN_UPDATE, false);
	$r->add_textbox("messages_number", TEXT);
	$r->change_property("messages_number", USE_IN_UPDATE, false);
	$r->add_textbox("last_post_added", DATETIME, "Last Post Added");
	$r->change_property("last_post_added", USE_IN_UPDATE, false);
	$r->add_textbox("last_post_user_id", INTEGER);
	$r->change_property("last_post_user_id", USE_IN_UPDATE, false);
	$r->add_textbox("last_post_thread_id", INTEGER);
	$r->change_property("last_post_thread_id", USE_IN_UPDATE, false);

	$r->get_form_values();
	$operation = get_param("operation");
	$forum_id = get_param("forum_id");

	if(strlen($operation))	{
		$is_valid = true;
		if($operation == "cancel") {
			header("Location: " . $r->return_page);
			exit;
		}
		else if($operation == "delete" && $forum_id)    // delete forum
		{
			// delete topics' messages
			$sql = "SELECT thread_id, topic FROM " . $table_prefix . "forum WHERE forum_id = " . $db->tosql($forum_id, INTEGER);
			$threads = get_db_values($sql, "");
			$threads_str = "";
			foreach ($threads as $thread) {
				if ($threads_str) {
					$threads_str .= ",";
				}
				else {
					$threads_str = "(";
				}
				$threads_str .= $thread[0];
			}
			if ($threads_str) {
				$threads_str .= ")";
				$db->query("DELETE FROM " . $table_prefix . "forum_messages WHERE thread_id IN " . $threads_str);
			}
			// delete moderators and topics
			$db->query("DELETE FROM " . $table_prefix . "forum_moderators WHERE forum_id = " . $db->tosql($forum_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "forum WHERE forum_id = " . $db->tosql($forum_id, INTEGER));

			$r->delete_record();
			header("Location: " . $r->return_page);
			exit;
		}	
		if($is_valid) {
			$is_valid = $r->validate();
		}
		if($is_valid)	{
			if(strlen($r->get_value("forum_id"))) {   // update existing forum
				set_friendly_url();
				$record_updated = $r->update_record();
			} else {
				set_friendly_url();
				$r->set_value("date_added", va_time());
				$r->set_value("last_post_user_id", 0);
				$r->set_value("last_post_thread_id", 0);
				$r->set_value("last_post_added", va_time());
				$record_updated = $r->insert_record(); // insert new forum
				if ($record_updated) {
					$sql = "SELECT MAX(forum_id) FROM " . $table_prefix . "forum_list";
					$forum_id = get_db_value($sql);
					$r->set_value("forum_id", $forum_id);
				}
			}
			if ($record_updated) {
				foreach($admins as $admin_id => $admin_name) {
					$admin = "admin_" . $admin_id;
					if ($usr->get_value($admin)) {
						$sql  = " SELECT forum_id FROM " . $table_prefix . "forum_moderators ";
						$sql .= " WHERE forum_id = " . $db->tosql($forum_id, INTEGER);
						$sql .= " AND admin_id = " . $db->tosql($admin_id, INTEGER);
						$db->query($sql);
						if (!$db->next_record()) {
							$sql  = " INSERT INTO " . $table_prefix . "forum_moderators (admin_id, forum_id) VALUES (";
							$sql .= $db->tosql($admin_id, INTEGER) . ", ";
							$sql .= $db->tosql($forum_id, INTEGER) . ")";
							$db->query($sql);
						}
					} else {
						$sql  = " DELETE FROM " . $table_prefix . "forum_moderators ";
						$sql .= " WHERE forum_id = " . $db->tosql($forum_id, INTEGER);
						$sql .= " AND admin_id = " . $db->tosql($admin_id, INTEGER);
						$db->query($sql);
					}
				}
 				header("Location: " . $r->return_page);
				exit;
			}
		}
	}
	else if(strlen($r->get_value("forum_id")))   	// show existing values 
	{
		$r->get_db_values();
		$r->set_value("date_added", va_date($datetime_show_format, $r->get_value("date_added")));
		$r->set_value("last_post_added", va_date($datetime_show_format, $r->get_value("last_post_added")));
		$admin_checked = array();
    	$sql  = " SELECT admin_id FROM " . $table_prefix . "forum_moderators ";
		$sql .= " WHERE forum_id = " . $db->tosql($forum_id, INTEGER);
		$db->query($sql);
		while($db->next_record()) {
			$admin_checked[$db->f("admin_id")] = 1;
		}
		foreach ($admins as $admin_id => $admin_name)
		{
			$admin = "admin_" . $admin_id;
			if (isset($admin_checked[$admin_id])) {
				if($admin_checked[$admin_id]) {
					$usr->set_value($admin, 1);
				}
				else {
					$usr->set_value($admin, 0);
				}
			}
			else {
				$usr->set_value($admin, 0);
			}
		}	
	}
	else // set default values
	{
		$forum_order = get_db_value("SELECT MAX(forum_order) FROM " . $table_prefix . "forum_list");
		$forum_order++;
		$r->set_value("forum_order", $forum_order);
		$r->set_value("allowed_view",         1);
		$r->set_value("allowed_view_topics",  1);
		$r->set_value("allowed_view_topic",   1);
		$r->set_value("allowed_post_topics",  1);
		$r->set_value("allowed_post_replies", 1);
		$r->set_value("threads_number", 0);
		$r->set_value("messages_number", 0);
		$r->set_value("date_added", va_time());
		$r->set_value("last_post_user_id", 0);
		$r->set_value("last_post_thread_id", 0);
		$r->set_value("last_post_added", va_time());
	}

	foreach($admins as $admin_id => $admin_name) {
		$admin = "admin_" . $admin_id;
		$admin_name_checked = $usr->get_value($admin) ? "checked" : "";
		$admin_checkbox = "<input type=\"checkbox\" name=\"$admin\" $admin_name_checked value=\"$admin_id\">";
		$t->set_var("admin_name", $admin_name);
		$t->set_var("admin_checkbox", $admin_checkbox);
		$t->parse("admin_rows", true);
	}

	$r->set_parameters();
	if($r->get_value("forum_id")) {
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else {
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_href", "admin.php");
	$t->pparse("main");

?>