<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  admin_packing_pdf.php                                    ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once($root_folder_path . "includes/record.php");
	include_once($root_folder_path . "includes/order_items.php");
	include_once($root_folder_path . "includes/parameters.php");
	include_once($root_folder_path . "includes/pdflib.php");
	include_once($root_folder_path . "includes/pdf.php");
	include_once($root_folder_path . "messages/" . $language_code . "/cart_messages.php");

	check_admin_security("sales_orders");

	$currency = get_currency();

	// additional connection 
	$dbi = new VA_SQL();
	$dbi->DBType      = $db_type;
	$dbi->DBDatabase  = $db_name;
	$dbi->DBUser      = $db_user;
	$dbi->DBPassword  = $db_password;
	$dbi->DBHost      = $db_host;
	$dbi->DBPort      = $db_port;
	$dbi->DBPersistent= $db_persistent;

	$packing = array();
	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='printable'";
	$db->query($sql);
	while ($db->next_record()) {
		$packing[$db->f("setting_name")] = $db->f("setting_value");
	}

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_info'";
	$db->query($sql);
	while ($db->next_record()) {
		$order_info[$db->f("setting_name")] = $db->f("setting_value");
	}

/*
	$t->set_var("CART_TITLE",          CART_TITLE);     
	$t->set_var("EMPTY_CART_MSG",      EMPTY_CART_MSG);     
	$t->set_var("PROD_TITLE_COLUMN",   PROD_TITLE_COLUMN);     
	$t->set_var("PROD_QTY_COLUMN",     PROD_QTY_COLUMN);         
	$t->set_var("PROD_PRICE_COLUMN",   PROD_PRICE_COLUMN);       
	$t->set_var("PROD_TOTAL_COLUMN",   PROD_TOTAL_COLUMN);  
	$t->set_var("GOODS_TOTAL_MSG",     GOODS_TOTAL_MSG); 
	$t->set_var("TOTAL_DISCOUNT_MSG",  TOTAL_DISCOUNT_MSG); 
	$t->set_var("GOODS_WITH_DISCOUNT_MSG",GOODS_WITH_DISCOUNT_MSG); 
	$t->set_var("CART_TOTAL_MSG",      CART_TOTAL_MSG);     

	$t->set_var("PERSONAL_DETAILS_MSG", PERSONAL_DETAILS_MSG);
	$t->set_var("DELIVERY_DETAILS_MSG", DELIVERY_DETAILS_MSG);
	$t->set_var("PAYMENT_DETAILS_MSG",  PAYMENT_DETAILS_MSG);
*/

	$ids = get_param("ids");
	$order_id = get_param("order_id");
	if ($order_id) {
		$ids = $order_id;
	}

	$r = new VA_Record($table_prefix . "orders");
	$r->add_where("order_id", INTEGER);

	$personal_number = 0;
	$delivery_number = 0;
	for ($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		$personal_param = "show_" . $parameters[$i];
		$delivery_param = "show_delivery_" . $parameters[$i];
		$r->add_textbox($parameters[$i], TEXT);
		$r->add_textbox("delivery_" . $parameters[$i], TEXT);
		if (isset($order_info[$personal_param]) && $order_info[$personal_param] == 1) {
			$personal_number++;
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if (isset($order_info[$delivery_param]) && $order_info[$delivery_param] == 1) {
			$delivery_number++;
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$r->add_textbox("user_id", INTEGER);
	$r->add_textbox("payment_id", INTEGER);
	$r->add_textbox("order_placed_date", DATETIME);
	$r->add_textbox("currency_code", TEXT);
	$r->add_textbox("shipping_tracking_id", TEXT);
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("cc_name", TEXT);
	$r->add_textbox("cc_first_name", TEXT);
	$r->add_textbox("cc_last_name", TEXT);
	$r->add_textbox("cc_number", TEXT);
	$r->add_textbox("cc_start_date", DATETIME);
	$r->change_property("cc_start_date", VALUE_MASK, array("MM", " / ", "YYYY"));
	$r->add_textbox("cc_expiry_date", DATETIME);
	$r->change_property("cc_expiry_date", VALUE_MASK, array("MM", " / ", "YYYY"));
	$r->add_textbox("cc_type", INTEGER);
	$r->add_textbox("cc_issue_number", INTEGER);
	$r->add_textbox("cc_security_code", TEXT);
	$r->add_textbox("pay_without_cc", TEXT);

	// General PDF information
	$pdf_library = isset($packing["pdf_lib"]) ? $packing["pdf_lib"] : 1;
	if ($pdf_library == 2) {
		$pdf = new VA_PDFLib();
	} else {
		$pdf = new VA_PDF();
	}
	$pdf->set_creator("admin_packing_pdf.php");
	$pdf->set_author("ViArt Ltd");
	$pdf->set_title("Packing Sleep No: " . $ids);
	$page_number = 0;

	$order_ids = explode(",", $ids);
	for ($i = 0; $i < sizeof($order_ids); $i++) 
	{
		$id = $order_ids[$i];
		$r->set_value("order_id", $id);
		$r->get_db_values();
  
		$order_placed_date = $r->get_value("order_placed_date");
		$order_date = va_date($date_show_format, $order_placed_date);
		//$t->set_var("order_date", $order_date);
  
		$r->set_value("company_id", get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($r->get_value("company_id"), INTEGER)));
		$r->set_value("state_code", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($r->get_value("state_code"), TEXT)));
		$r->set_value("country_code", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($r->get_value("country_code"), TEXT)));
		$r->set_value("delivery_company_id", get_db_value("SELECT company_name FROM " . $table_prefix . "companies WHERE company_id=" . $db->tosql($r->get_value("delivery_company_id"), INTEGER)));
		$r->set_value("delivery_state_code", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($r->get_value("delivery_state_code"), TEXT)));
		$r->set_value("delivery_country_code", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($r->get_value("delivery_country_code"), TEXT)));
		$r->set_value("cc_type", get_db_value("SELECT credit_card_name FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($r->get_value("cc_type"), INTEGER)));
  
  
		$packing_slips = array();
		$sql  = " SELECT oe.order_items FROM (" . $table_prefix . "orders_events oe ";
		$sql .= " LEFT JOIN " . $table_prefix . "order_statuses os ON os.status_id=oe.status_id) ";
		$sql .= " WHERE order_id=" . $db->tosql($id, INTEGER);
		$sql .= " AND os.is_dispatch=1 ";
		$db->query($sql);
		if ($db->next_record()) {
		 	do {
				$packing_slips[] = $db->f("order_items");
			} while ($db->next_record());
		} else {
			$packing_slips[] = "";
		}
  
		for ($ps = 0; $ps < sizeof($packing_slips); $ps++)
		{
			begin_new_page();		
    
			set_packing_header();
			set_user_info();
			set_table_header();
  
			$order_items = $packing_slips[$ps];
			$sql  = " SELECT * FROM " . $table_prefix . "orders_items ";
			$sql .= " WHERE order_id=" . $db->tosql($id, INTEGER);
			if (strlen($order_items)) {
				$sql .= " AND order_item_id IN (" . $db->tosql($order_items, TEXT, false) . ") ";
			}
			$db->query($sql);
			while ($db->next_record()) {
				if ($height_position < 140) {
					$pdf->end_page();
					begin_new_page();		
					set_table_header();
				}
  
				$order_item_id = $db->f("order_item_id");
				$quantity = $db->f("quantity");
				$item_name = strip_tags(get_translation($db->f("item_name")));
				$item_properties = $db->f("item_properties");
				$manufacturer_code = $db->f("manufacturer_code");
  
				$pdf->setfont ("helvetica", "", 10);
				$fontsize = 10; 
  
				$item_height = $pdf->show_xy($item_name, 105, $height_position - 2, 290, 0);
				$item_height += 6;
  
				$pdf->show_xy($quantity, 40, $height_position - 2, 60, 0, "center");
				$pdf->show_xy($manufacturer_code, 400, $height_position - 2, 155, 0, "center");
				$height_position -= $item_height;
				
  
				$pdf->setfont ("helvetica", "", 9);
				$properties_height = 0;
				$sql  = " SELECT property_name, property_value FROM " . $table_prefix . "orders_items_properties ";
				$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
				$dbi->query($sql);
				while ($dbi->next_record()) {
					$property_name = strip_tags(get_translation($dbi->f("property_name")));
					$property_value = strip_tags(get_translation($dbi->f("property_value")));
					$property_line = $property_name . ": " . $property_value;
  
					$property_height = $pdf->show_xy($property_line, 115, $height_position - $properties_height + 2, 280, 0);
					$properties_height += $property_height;
				}
  
				if ($properties_height > 0) {
					$properties_height += 2;
					$height_position -= $properties_height;
				}
  
				$pdf->setlinewidth(1.0);
				$pdf->rect(40, $height_position, 515, $item_height + $properties_height);
				$pdf->line(100, $height_position, 100, $height_position + $item_height + $properties_height);
				$pdf->line(400, $height_position, 400, $height_position + $item_height + $properties_height);
  
  
			}
  
			set_packing_footer();
			$pdf->end_page();
		}
	}

	$buffer = $pdf->get_buffer();
	$length = strlen($buffer);

	$pdf_filename = "packing_slip_" . str_replace(",", "_", $ids) . ".pdf";
	header("Content-Type: application/x-ms-download"); 
	//header("Content-Type: application/pdf");
	//header("Content-Type: application/force-download");
	//header("Content-Type: application/octet-stream");
	header("Content-Length: " . $length); 
	header("Content-Disposition: attachment; filename=" . $pdf_filename); 
	header("Content-Transfer-Encoding: binary"); 
	header("Cache-Control: max-age=0"); 

	echo $buffer;



function begin_new_page()
{
	global $pdf, $page_number, $height_position;

	$page_number++;
	$pdf->begin_page(595, 842);
	$height_position = 800;

	$pdf->setfont ("helvetica", "", 8);
	if ($page_number > 1) {
		//$pdf->show_xy("- " . $page_number . " -", 40, 20, 555, 0, "center");
	}
}

function set_table_header()
{
	global $pdf, $height_position;
	global $helvetica, $helvetica_bold;

	$pdf->setlinewidth(1.0);
	
	$height_position -= 12;
	$pdf->rect (40, $height_position - 24, 515, 24);
	$pdf->line (100, $height_position - 24, 100, $height_position);
	$pdf->line (400, $height_position - 24, 400, $height_position);
	$pdf->setfont ("helvetica", "B", 10);
	$pdf->show_xy ("Qty", 40, $height_position - 6, 60, 0, "center");
	$pdf->show_xy ("Description", 100, $height_position - 6, 300, 0, "center");
	$pdf->show_xy ("Code", 400, $height_position - 6, 155, 0, "center");

	$height_position -= 24;
}


function set_user_info()
{
	global $pdf, $height_position;
	global $r, $parameters, $personal_number, $delivery_number;
	global $packing, $helvetica, $helvetica_bold, $order_date;

	$pdf->setfont ("helvetica", "BU", 10);
	$height_position -= 24;
	$pdf->show_xy(INVOICE_TO_MSG.":", 40, $height_position, 250, 0, "left");
	if ($delivery_number > 0) {
		$pdf->show_xy(DELIVERY_TO_MSG.":", 300, $height_position, 250, 0, "left");
	}

	$personal_height = $height_position;
	$pdf->setfont("helvetica", "", 10);

	$name = "";
	if ($r->parameters["name"][SHOW]) {
		$name = $r->get_value("name");
	}
	if ($r->parameters["first_name"][SHOW] && $r->get_value("first_name")) {
		if ($name) { $name .= " "; }
		$name .= $r->get_value("first_name");
	}
	if ($r->parameters["last_name"][SHOW] && $r->get_value("last_name")) {
		if ($name) { $name .= " "; }
		$name .= $r->get_value("last_name");
	}

	if (strlen($name)) {
		$personal_height -= 12;
		$pdf->show_xy($name, 40, $personal_height, 250, 0, "left");
	}

	if ($r->parameters["address1"][SHOW] && $r->get_value("address1")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("address1"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["address2"][SHOW] && $r->get_value("address2")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("address2"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["company_id"][SHOW] && $r->get_value("company_id")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("company_id"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["company_name"][SHOW] && $r->get_value("company_name")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("company_name"), 40, $personal_height, 250, 0, "left");
	}

	$city = ""; $address_line = "";
	if ($r->parameters["city"][SHOW]) {
		$city = $r->get_value("city");
	}
	if ($r->parameters["province"][SHOW]) {
		$address_line = $r->get_value("province");
	}
	if ($r->parameters["state_code"][SHOW] && $r->get_value("state_code")) {
		if ($address_line) { $address_line .= " "; }
		$address_line .= $r->get_value("state_code");
	}
	if ($r->parameters["zip"][SHOW] && $r->get_value("zip")) {
		if ($address_line) { $address_line .= " "; }
		$address_line .= $r->get_value("zip");
	}
	if (strlen($city) && strlen($address_line)) {
		$address_line = $city . ", " . $address_line;
	} elseif (strlen($city)) {
		$address_line = $city;
	}

	if (strlen($address_line)) {
		$personal_height -= 12;
		$pdf->show_xy($address_line, 40, $personal_height, 250, 0, "left");
	}

	if ($r->parameters["country_code"][SHOW] && $r->get_value("country_code")) {
		$personal_height -= 12;
		$pdf->show_xy($r->get_value("country_code"), 40, $personal_height, 250, 0, "left");
	}

	if ($r->parameters["phone"][SHOW] && !$r->is_empty("phone")) {
		$personal_height -= 12;
		$pdf->show_xy(PHONE_FIELD.": ".$r->get_value("phone"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["daytime_phone"][SHOW] && !$r->is_empty("daytime_phone")) {
		$personal_height -= 12;
		$pdf->show_xy(DAYTIME_PHONE_FIELD.": ".$r->get_value("daytime_phone"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["evening_phone"][SHOW] && !$r->is_empty("evening_phone")) {
		$personal_height -= 12;
		$pdf->show_xy(EVENING_PHONE_FIELD.": ".$r->get_value("evening_phone"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["cell_phone"][SHOW] && !$r->is_empty("cell_phone")) {
		$personal_height -= 12;
		$pdf->show_xy(CELL_PHONE_FIELD.": ".$r->get_value("cell_phone"), 40, $personal_height, 250, 0, "left");
	}
	if ($r->parameters["fax"][SHOW] && !$r->is_empty("fax")) {
		$personal_height -= 12;
		$pdf->show_xy(FAX_FIELD.": ".$r->get_value("fax"), 40, $personal_height, 250, 0, "left");
	}

	if ($r->parameters["email"][SHOW] && strlen($r->get_value("email"))) {
		$personal_height -= 12;
		$pdf->show_xy(EMAIL_FIELD.": " . $r->get_value("email"), 40, $personal_height, 250, 0, "left");
	}

	$delivery_height = $height_position;

	$delivery_name = "";
	if ($r->parameters["delivery_name"][SHOW]) {
		$delivery_name = $r->get_value("delivery_name");
	}
	if ($r->parameters["delivery_first_name"][SHOW] && $r->get_value("delivery_first_name")) {
		if ($delivery_name) { $delivery_name .= " "; }
		$delivery_name .= $r->get_value("delivery_first_name");
	}
	if ($r->parameters["delivery_last_name"][SHOW] && $r->get_value("delivery_last_name")) {
		if ($delivery_name) { $delivery_name .= " "; }
		$delivery_name .= $r->get_value("delivery_last_name");
	}

	if (strlen($delivery_name)) {
		$delivery_height -= 12;
		$pdf->show_xy($delivery_name, 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_address1"][SHOW] && $r->get_value("delivery_address1")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_address1"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_address2"][SHOW] && $r->get_value("delivery_address2")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_address2"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_company_id"][SHOW] && $r->get_value("delivery_company_id")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_company_id"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_company_name"][SHOW] && $r->get_value("delivery_company_name")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_company_name"), 300, $delivery_height, 250, 0, "left");
	}

	$delivery_city = ""; $delivery_address = "";
	if ($r->parameters["delivery_city"][SHOW]) {
		$delivery_city = $r->get_value("delivery_city");
	}
	if ($r->parameters["delivery_province"][SHOW]) {
		$delivery_address = $r->get_value("delivery_province");
	}
	if ($r->parameters["delivery_state_code"][SHOW] && $r->get_value("delivery_state_code")) {
		if ($delivery_address) { $delivery_address .= " "; }
		$delivery_address .= $r->get_value("delivery_state_code");
	}
	if ($r->parameters["delivery_zip"][SHOW] && $r->get_value("delivery_zip")) {
		if ($delivery_address) { $delivery_address .= " "; }
		$delivery_address .= $r->get_value("delivery_zip");
	}
	if (strlen($delivery_city) && strlen($delivery_address)) {
		$delivery_address = $delivery_city . ", " . $delivery_address;
	} elseif (strlen($delivery_city)) {
		$delivery_address = $delivery_city;
	}

	if (strlen($delivery_address)) {
		$delivery_height -= 12;
		$pdf->show_xy($delivery_address, 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_country_code"][SHOW] && $r->get_value("delivery_country_code")) {
		$delivery_height -= 12;
		$pdf->show_xy($r->get_value("delivery_country_code"), 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_phone"][SHOW] && !$r->is_empty("delivery_phone")) {
		$delivery_height -= 12;
		$pdf->show_xy(PHONE_FIELD.": ".$r->get_value("delivery_phone"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_daytime_phone"][SHOW] && !$r->is_empty("delivery_daytime_phone")) {
		$delivery_height -= 12;
		$pdf->show_xy(DAYTIME_PHONE_FIELD.": ".$r->get_value("delivery_daytime_phone"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_evening_phone"][SHOW] && !$r->is_empty("delivery_evening_phone")) {
		$delivery_height -= 12;
		$pdf->show_xy(EVENING_PHONE_FIELD.": ".$r->get_value("delivery_evening_phone"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_cell_phone"][SHOW] && !$r->is_empty("delivery_cell_phone")) {
		$delivery_height -= 12;
		$pdf->show_xy(CELL_PHONE_FIELD.": ".$r->get_value("delivery_cell_phone"), 300, $delivery_height, 250, 0, "left");
	}
	if ($r->parameters["delivery_fax"][SHOW] && !$r->is_empty("delivery_fax")) {
		$delivery_height -= 12;
		$pdf->show_xy(FAX_FIELD.": ".$r->get_value("delivery_fax"), 300, $delivery_height, 250, 0, "left");
	}

	if ($r->parameters["delivery_email"][SHOW] && strlen($r->get_value("delivery_email"))) {
		$delivery_height -= 12;
		$pdf->show_xy(EMAIL_FIELD.": " . $r->get_value("delivery_email"), 300, $delivery_height, 250, 0, "left");
	}

	if ($personal_height > $delivery_height) {
		$height_position = $delivery_height;
	} else {
		$height_position = $personal_height;
	}
	$height_position -= 12;

}

function set_packing_header()
{
	global $pdf, $height_position;
	global $packing, $helvetica, $helvetica_bold, $order_date, $id;

	$image_height = 0;
	$start_position = $height_position;
	if (isset($packing["packing_logo"]) && strlen($packing["packing_logo"])) {
		$image_path = $packing["packing_logo"];
		$image_size = @GetImageSize($image_path);
		$image_width = $image_size[0];
		$image_height = $image_size[1];
		if ($image_width > 0 && $image_height > 0) {
			if (preg_match("/((\.jpeg)|(\.jpg))$/i", $image_path)) {
				$image_type = "jpeg";
			} elseif (preg_match("/(\.gif)$/i", $image_path)) {
				$image_type = "gif";
			} elseif (preg_match("/((\.tif)|(\.tiff))$/i", $image_path)) {
				$image_type = "tiff";
			} elseif (preg_match("/(\.png)$/i", $image_path)) {
				$image_type = "png";
			}
		  $pdf->place_image($image_path, 555 - $image_width, $height_position - $image_height, $image_type);
		}
	}

	if (isset($packing["packing_header"])) {
		$packing_header = strip_tags($packing["packing_header"]);
		if (strlen($packing_header)) {
			$pdf->setfont("helvetica", "", 10);
			$header_lines = explode("\n", $packing_header);
			for ($i = 0; $i < sizeof($header_lines); $i++) {
				$header_line = $header_lines[$i];
				$line_height = $pdf->show_xy($header_line, 40, $height_position, 200, 0, "left");
				$height_position -= ($line_height + 2);
			}
		}
	}

	$height_position -= 12;
	$pdf->setfont("helvetica", "B", 10);
	$pdf->show_xy("Order Date:", 40, $height_position, 80, 0, "left");
	$pdf->setfont("helvetica", "", 10);
	$pdf->show_xy($order_date, 120, $height_position, 200, 0, "left");

	$height_position -= 12;
	$pdf->setfont("helvetica", "B", 10);
	$pdf->show_xy("Order Number:", 40, $height_position, 80, 0, "left");
	$pdf->setfont("helvetica", "", 10);
	$pdf->show_xy($id, 120, $height_position, 200, 0, "left");

	if ($height_position > ($start_position - $image_height)) {
		$height_position = $start_position - $image_height;
	}

}

function set_packing_footer()
{
	global $pdf, $height_position;
	global $packing, $helvetica, $helvetica_bold, $order_date, $id;

	$pdf->setfont("helvetica", "", 8);
	if (isset($packing["packing_footer"])) {
		$packing_footer = strip_tags($packing["packing_footer"]);
		if (strlen($packing_footer)) {
			$footer_lines = explode("\n", $packing_footer);
			$height_position = 40 + sizeof($footer_lines) * 10;
			for ($i = 0; $i < sizeof($footer_lines); $i++) {
				$height_position -= 10;
				$footer_line = $footer_lines[$i];
				$pdf->show_xy($footer_line, 40, $height_position, 555, 0, "center");
			}
		}
	}

}

?>