<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  admin_support_predefined_edit.php                        ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	// get permissions
	$permissions = get_permissions();
	$allow_predefined_edit  = get_setting_value($permissions, "support_predefined_reply", 0); 

	check_admin_security("support");
	$is_popup = get_param("is_popup");
	$body_class = ($is_popup) ? "popup" : "commonbg";

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_support_predefined_edit.html");

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_support_type_href", "admin_support_predefined_edit.php");
	$t->set_var("admin_support_types_href", "admin_support_predefined.php");

	$r = new VA_Record($table_prefix . "support_predefined");
	$r->return_page = "admin_support_predefined.php?is_popup=$is_popup";

	$r->add_where("reply_id", INTEGER);
	$r->add_textbox("subject", TEXT, "Subject");
	$r->parameters["subject"][REQUIRED] = true;
	$r->add_textbox("body", TEXT, "Body");
	$reply_types = get_db_values("SELECT DISTINCT reply_type, reply_type FROM ".$table_prefix."support_predefined", array(array("", "Select Reply Type")));
	$r->add_select("reply_type", TEXT, $reply_types, "Type");
	$r->parameters["reply_type"][REQUIRED] = true;

	$r->set_event(BEFORE_DELETE,   "check_predefined_permissions");
	$r->set_event(BEFORE_VALIDATE, "check_predefined_permissions");

	$r->process();
	if ($allow_predefined_edit) {
		$t->parse("edit_button", false);
	} else {
		$t->set_var("delete", "");
	}

	$t->set_var("is_popup",   $is_popup);
	$t->set_var("body_class", $body_class);

	if (strlen($is_popup)) { 						
 		$t->parse("closebutton",false);
	}	else {
 		$t->set_var("closebutton",""); 
		include("./admin_header.php");
		include("./admin_footer.php");
 		$t->parse("support_breadcrumb", false); 
 	}	

	$t->set_var("admin_href", "admin.php");

	$t->pparse("main");

	function check_predefined_permissions()
	{
		global $allow_predefined_edit;
		if (!$allow_predefined_edit) {
			die("Sorry, but you are not allowed to edit predefined replies.");
		}
	}

?>