<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                      ***
  ***      File:  cart_retrieve.php                                        ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

	$current_page = "cart_save.php";

	include_once ("./includes/common.php");
	include_once ("./includes/navigator.php");
	include_once ("./includes/items_properties.php");
	include_once ("./messages/".$language_code."/cart_messages.php");
	include_once ("./includes/shopping_cart.php");
	include_once ("./includes/record.php");

	$shopping_cart = get_session("shopping_cart");

	// load html template
	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","cart_retrieve.html");

	$t->set_var("basket_href",   "basket.php");
	$t->set_var("current_href",  "cart_retrieve.php");
	$t->set_var("checkout_href", "checkout.php");
	$t->set_var("products_href", "products.php");
	$t->set_var("cart_retrieve_href","cart_retrieve.php");

	// set up return page
	$rp = get_param("rp");
	if(!$rp) { $rp = "products.php"; }
	$t->set_var("rp", htmlspecialchars($rp));

	$operation = get_param("operation");
	$user_id = get_session("session_user_id");

	$r = new VA_Record($table_prefix . "saved_carts");
	$r->add_textbox("cart_id", INTEGER, CART_NO_FIELD);
	$r->change_property("cart_id", REQUIRED, true);
	$r->add_textbox("cart_name", TEXT, CART_NAME_FIELD);
	if (!$user_id) {
		$r->change_property("cart_name", REQUIRED, true);
	}

	if(strlen($operation)) 
	{
		if ($operation == "cancel") {
			header("Location: basket.php?rp=" . urlencode($rp));
			exit;
		} 
		$r->get_form_values();

		$is_valid = $r->validate();
		if ($is_valid) {
			$sql  = " SELECT cart_id FROM " . $table_prefix . "saved_carts ";
			$sql .= " WHERE cart_id=" . $db->tosql($r->get_value("cart_id"), INTEGER);
			$sql .= " AND (cart_name=" . $db->tosql($r->get_value("cart_name"), TEXT);
			if ($user_id) {
				$sql .= " OR user_id=" . $db->tosql($user_id, INTEGER);
			}
			$sql .= ")";
			$db->query($sql);
			if(!$db->next_record()) {
				$is_valid = false;
				$r->errors = RETRIEVE_CART_ERROR;
			}
		}

		if ($is_valid) {
			// clear current cart
			set_session("shopping_cart", "");
			set_session("session_coupons", "");

			// Database Initialize
			$dbi = new VA_SQL();
			$dbi->DBType      = $db_type;
			$dbi->DBDatabase  = $db_name;
			$dbi->DBHost      = $db_host;
			$dbi->DBPort      = $db_port;
			$dbi->DBUser      = $db_user;
			$dbi->DBPassword  = $db_password;
			$dbi->DBPersistent= $db_persistent;

			// retrieve cart
			$sql  = " SELECT * FROM " . $table_prefix . "saved_items ";
			$sql .= " WHERE cart_id=" . $db->tosql($r->get_value("cart_id"), INTEGER);
			$sql .= " ORDER BY cart_item_id ";
			$dbi->query($sql);
			if ($dbi->next_record()) {
				do {
					$sc_errors = "";
					$cart_item_id = $dbi->f("cart_item_id");
					$item_id = $dbi->f("item_id");
					$item_name = $dbi->f("item_name");
					$quantity = $dbi->f("quantity");
					$price = $dbi->f("price");

					// add to cart
					add_to_cart($item_id, $price, $quantity, "db", $new_cart_id, $second_page_options, $sc_errors, $cart_item_id, $item_name);

				} while ($dbi->next_record());
			}

			header("Location: basket.php?rp=" . urlencode($rp));
			exit;
		}
			
	}

	$r->set_parameters();

	$t->set_var("rp", htmlspecialchars($rp));

	include("./header.php");
	include("./footer_php.php");

	$t->pparse("main");

?>